// MySQL.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "MySQL.h"
#include <afxdb.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// The one and only application object

CWinApp theApp;

static volatile LONG counter = 0;
UINT Thread(LPVOID)
{
	TCHAR buf[100];
	InterlockedIncrement(&counter);
	if (counter < 3)
		_stprintf(buf, _T("Click to exit thread %d only after thread 3 and 4 are running.\n"), counter);
	else
		_stprintf(buf, _T("Click to exit thread %d only after thread messages 1 and 2 was clicked.\n"), counter);

	AfxMessageBox(buf);
	return 0;
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		return 1;
	}
	
	// create two threads that will make bug happen
	// let the message boxes opened for first and second threads.
	HANDLE h = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)Thread, NULL, 0, NULL);
	h = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)Thread, NULL, 0, NULL);
	Sleep(100);

	// open database
	CDatabase db;
	db.OpenEx(_T("MySQLODBC"));

	// create threads with MySQL ODBC loaded
	// MySQL ODBC will create critical session and semaphore in TLS in DllMain for each thread
	
	h = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)Thread, NULL, 0, NULL);
	h = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)Thread, NULL, 0, NULL);

	Sleep(100);
	
	// Now click thread 1 and 2 message box to let them terminate. 
	// MySQL ODBC DllMain will try to release TLS data and will fail due no TLS data associated
	// with those threads and decrement threads counter by two reaching zero. 
	// The third and fourth threads will terminate too, but it's TLS data
	// will not be freed due threads counter equals zero.
	AfxMessageBox(_T("Now click thread messages #1 and #2 to make bug happen.\nAfter this, click thread messages #3 and #4 that have\nTLS data stored for them."));

	db.Close();

	return 0;
}
